# -*- coding: utf-8 -*-

from datetime import date
from dateutil import relativedelta

from odoo import models
from odoo.tools import misc


class Campaign(models.Model):

    _inherit = "marketing.campaign"

    def _find_duplicate_workitems(self, record):
        """Override to allow filtering the workitems for the Odoo Saas Campaign
           A customer should only be in the campaign once every 3 months
        """
        saas_campaign = self.env.ref('openerp_enterprise.saas_campaign').id
        if self.id == saas_campaign:
            duplicate_workitem_domain = [('res_id', '=', record.id), ('campaign_id', '=', self.id)]
            if getattr(record, 'email_from', None):
                limit_date = (date.today() - relativedelta.relativedelta(months=3)).strftime(misc.DEFAULT_SERVER_DATE_FORMAT)
                result = self.env[self.object_id.model].search([('email_from', '=', record.email_from), ('create_date', '>', limit_date)])
                if result:
                    duplicate_workitem_domain = [('res_id', 'in', result.ids),
                                                 ('campaign_id', '=', self.id),
                                                 ('create_date', '>', limit_date)]
            return self.env['marketing.campaign.workitem'].search(duplicate_workitem_domain)
        return super(Campaign, self)._find_duplicate_workitems(record)
